/***************************************************************************
 *            gtkdatabox_text.h
 *
 *  Copyright(C) 2005  J.C.Remis & Dr. Roland Bock
 ****************************************************************************/
/* GtkDatabox - An extension to the gtk+ library
 * Copyright (C) 1998 - 2005  Dr. Roland Bock
 */
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _GTKDATABOX_TEXT_H
#define _GTKDATABOX_TEXT_H

#ifdef __cplusplus
extern "C"
{
#endif
   
   typedef enum
   {
      GTK_DATABOX_TEXT_CENTER       = 0, /* text centered on data */
      GTK_DATABOX_TEXT_N,                /* text north      of data */
      GTK_DATABOX_TEXT_NE,               /* text north-east of data */
      GTK_DATABOX_TEXT_E,                /* text east       of data */
      GTK_DATABOX_TEXT_SE,               /* text south-east of data */
      GTK_DATABOX_TEXT_S,                /* text south      of data */
      GTK_DATABOX_TEXT_SW,               /* text south-west of data */
      GTK_DATABOX_TEXT_W,                /* text west       of data */
      GTK_DATABOX_TEXT_NW,               /* text north-west of data */
   }
   GtkDataboxTextPosition;

   typedef struct
   {
      PangoLayout *text;                 /* The text */
      GtkDataboxTextPosition position;   /* position relative to data */
      gboolean boxed;                    /* box around text */
   }
   GtkDataboxText;

   void             
   gtk_databox_text_draw (GtkDatabox * box, GtkDataboxData * data);
   
   void
   gtk_databox_text_cleanup (GtkDatabox * box, GtkDataboxData * data);
   
   gint
   gtk_databox_text_write_at (GtkDatabox * box, PangoLayout *pl, GdkGC *gc, 
                              GtkDataboxCoord coord, 
                              GtkDataboxTextPosition position,
                              gint distance, 
                              gboolean boxed);
   gint 
   gtk_databox_text_set_texts (GtkDatabox * box, gint index, 
                               GtkDataboxText *texts, gint length);
   
   gint 
   gtk_databox_text_get_texts (GtkDatabox * box, gint index, PangoLayout **pl);
   
#ifdef __cplusplus
}
#endif

#endif /* _GTKDATABOX_TEXT_H */
